# Copyright 2009 Virginia Polytechnic Institute and State University  
#
# Licensed under the Apache License, Version 2.0 (the "License"); 
# you may not use this file except in compliance with the License. 
# You may obtain a copy of the License at 
# 
# http://www.apache.org/licenses/LICENSE-2.0 
#
# Unless required by applicable law or agreed to in writing, software 
# distributed under the License is distributed on an "AS IS" BASIS, 
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
# See the License for the specific language governing permissions and 
# limitations under the License. 


# Simple Python demonstration script for using
# the CROSS system.
#
# Use with demo.xml shell configuration file
#   Instructions:
# 	Start shell with demo.xml config from the examples directory
#	Start cognitive engine
#	Run this script
#	

from cross.cross import *

import time

def main():
	CN1 = "localhost"
	CN2 = "40000"

	SetCrossShellLocation(CN1,CN2)

	p = Parameter(2)
	currentParameters = Parameter(2)
	o = Observable(2)
	u = Utility(2)

	u[0].name = "throughput"
	u[1].name = "PER"

	numParameters = GetNum("parameters");
	numObservables = GetNum("observables");
	numUtilities = GetNum("utilities");

	for i in range(0,10):
		if i is 1:
			currentParameters[0].name = "bandwidth"
			currentParameters[0].value = 200.0 

			currentParameters[1].name = "bandwidth"
			currentParameters[1].value = 10.0 
		else:
			currentParameters[0].value = p[0].value 
			currentParameters[1].value = p[1].value

		print "Application:: Requesting parameter optimization"

		p = GetOptimalParameters(o,0,currentParameters,2,u,2)

		print "Application:: Receive the following parameters.\n"

		u[0].value = 2*p[0].value + 1*p[1].value
		u[1].value = 12 - p[0].value/50 - p[1].value/3

		print "utilities " + u[0].name + " = " + str(u[0].value) + "\n"
        	print "utilities " + u[1].name + " = " + str(u[1].value) + "\n"
 
		time.sleep(0.5)

		UpdateParameterPerformance(p, 2, o, 0, u, 2)

if __name__ == "__main__":
	main()
