/*
 Copyright 2009 Virginia Polytechnic Institute and State University  

 Licensed under the Apache License, Version 2.0 (the "License"); 
 you may not use this file except in compliance with the License. 
 You may obtain a copy of the License at 
 
 http://www.apache.org/licenses/LICENSE-2.0 

 Unless required by applicable law or agreed to in writing, software 
 distributed under the License is distributed on an "AS IS" BASIS, 
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 See the License for the specific language governing permissions and 
 limitations under the License. 
*/


#include <cstdlib>
#include <cstring>
#include <stdint.h>

#include "vtcross/debug.h"
#include "vtcross/error.h"
#include "vtcross/libvtcross.h"
#include "vtcross/socketcomm.h"
#include <iostream>

int32_t 
main(int32_t argc, char *argv[])
{
    /* Set the location to localhost for this simple demo. */
    SetCrossShellLocation("localhost", "40000");


// need to include utilties also in system,.. 

        Observable *o = new Observable[10];
        Parameter *currentParameters = new Parameter[10];
        Utility *u = new Utility[10];
        Parameter *p;

        uint32_t numParameters;
        uint32_t numObservables;
        uint32_t numUtilities;

        u[0].name = "throughput";
//        u[0].value = 15
        u[1].name = "PER";
//        u[1].value = 12.00;

        numParameters = GetNum("parameters");
        numObservables = GetNum("observables");
        numUtilities = GetNum("utilities");


// This is for loop for performing 10 cycles of updates.. with CBR
    for(size_t i = 0; i < 10; i++) {

        if(i == 0) {
            currentParameters[0].name = "bandwidth";
            currentParameters[0].value = 200.0;
            currentParameters[1].name = "tx_power";
            currentParameters[1].value = 10.0;
        } else {
            currentParameters[0].value = p[0].value;
            currentParameters[1].value = p[1].value;
        }

        LOG("Application:: Requesting parameter optimization.\n");

        p = GetOptimalParameters(o,0,currentParameters,2,u,2);

        LOG("Application:: Received the following parameters.\n");
        
        for(size_t i = 0; i < numParameters; i++) {
            LOG("%s:: %f\n", p[i].name.c_str(), p[i].value);
        }

///        Try them out! Do they work? 
        u[0].value = 2*p[0].value + 1*p[1].value + ((rand()*2.0/RAND_MAX - 1)*10.0);
        u[1].value = 12-p[0].value/50 - p[1].value/3 + ((rand()*2.0/RAND_MAX - 1.0)*0.1);

	if (u[1].value < 0) 
		u[1].value = 0; 

	LOG("utilities\n %s : %f \n %s : %f \n",u[0].name.c_str(),u[0].value,u[1].name.c_str(),u[1].value);	

        UpdateParameterPerformance(p, numParameters, o, numObservables, u, numUtilities);    

	usleep(1000);        
 
    }

    return 0;
}

